#if defined (MAX_TIMER)

//--------------------------------------------------------
struct struct_TIMER{
  bool on_off;
  char timer_name[CMD_LEN];
  char cmd_start[CMD_LEN];
  char cmd_active[CMD_LEN];
  char cmd[CMD_LEN];
  uint32_t time_from=0;
  uint32_t time_to=0;
  GH::Flags week=255;
  GH::Flags lamp=0;
  GH::Flags modul=0;
  uint32_t timer=15; //15 минут по умолчанию
  uint32_t tik_tik=0;
  bool ok=true;
  GH::Color col=gh::Colors::Aqua;
  bool old_on_off=true;
  uint32_t time_off=0;
//  char rezerv_byte[4];
};
struct_TIMER TIMER[MAX_TIMER];
FS_(TIMER);
//--------------------------------------------------------
void setup_TIMER(){
  strcpy(TIMER[0].timer_name, "STARTUP");
  FS_LOAD(TIMER); 
  FOR(tab,0,MAX_TIMER) {
      TIMER[tab].on_off=false;
      TIMER[tab].old_on_off=true;
  }
  strcat(main_menu, TIMER_MENU);
  strcat(main_menu, ";");
}
//--------------------------------------------------------
void show_tik_TIM(gh::Builder& b, uint8_t i) {
    bool dsbl, nolbl, notab;
    char arg1[10];
    TIMER[i].time_off=0;
    sprintf_P(arg1, (const char *)F("tik_TIM%u\0"), i);
    if (TIMER[i].on_off) TIMER[i].time_off=(TIMER[i].tik_tik-millis())/1000;
    b.Time_(arg1,&TIMER[i].time_off).label("оставшееся время").color(TIMER[i].col).fontSize(14).rows(1).size(2);
}
//--------------------------------------------------------
void hub_update_loop_TIMER(){
  char arg1[10];
  FOR_i(0,MAX_TIMER)
  {
   if (!TIMER[i].old_on_off==TIMER[i].on_off) {

      if (hub.focused()) { 
          if (TIMER[i].on_off) TIMER[i].time_off=(TIMER[i].tik_tik-millis())/1000; else TIMER[i].time_off=0;
          sprintf_P(arg1, (const char *)F("sw_TIM%u"), i);
          hub.update(arg1).value(bool (TIMER[i].on_off));
          sprintf_P(arg1, (const char *)F("tik_TIM%u"), i);
          DEBUG("hub_update_loop_TIMER : ");
          DEBUGLN(arg1);
          DEBUGLN(TIMER[i].time_off);
          hub.sendUpdate(arg1);
//          hub.sendUpdate(arg1,&TIMER[i].time_off);
       }
       
     TIMER[i].old_on_off=TIMER[i].on_off;
     #ifndef GH_NO_MQTT   // Отсылка значений на MQTT сервер
        hub.sendGet(arg1,TIMER[i].on_off);
     #endif
     }
    } // FOR
}
//--------------------------------------------------------
void send_on_time(uint8_t i, char act[]) {
 if (strlen(act))
   if (TIMER[i].week.get(dayofweek)) {
     bool on_time=false;
     if (TIMER[i].time_from<TIMER[i].time_to) 
         on_time=(hour*60+minute>=round(TIMER[i].time_from/60)) && (hour*60+minute<round(TIMER[i].time_to/60));
     else    
         on_time=(hour*60+minute>=round(TIMER[i].time_from/60)) || (hour*60+minute<round(TIMER[i].time_to/60));
     if (on_time) {
           all_parsig(TIMER[i].lamp,TIMER[i].modul,act);
//           module_parsig(TIMER[i].modul,act);
//           IP_parsig(TIMER[i].lamp,act);
     }
   }   
}
//--------------------------------------------------------
void loop_TIMER(){
  EVERY_MS(1000) {
  FS_TICK(TIMER); 
  FOR_i(0,MAX_TIMER) {
    if (TIMER[i].on_off) {
      if (TIMER[i].tik_tik<millis())
      {
        TIMER[i].tik_tik=0;
        TIMER[i].on_off=false;
        send_on_time(i,TIMER[i].cmd);
      } else {
        if (TIMER[i].ok) {  //запуск таймера
           TIMER[i].ok=false;
           send_on_time(i,TIMER[i].cmd_start);
        }
        send_on_time(i,TIMER[i].cmd_active);
      }
    } else TIMER[i].ok=true;
  } // for
  hub_update_loop_TIMER();
  } // EVERY_MS(1000)
}
//--------------------------------------------------------
void parsing_TIMER(char act[]){
  DEBUGLN("parsing_TIMER");
  DEBUGLN(act);
    if (!strcmp_P(act, PSTR(""))) return;
  
    if (!strncmp_P(act, PSTR("TIM"),3)) {
        uint8_t i=atol(char_parsung[1].act);
        if (i<MAX_TIMER) {
          if (!strncmp_P(char_parsung[2].act, PSTR("OF"),2)) TIMER_Start(i,false); else
          if (!strncmp_P(char_parsung[2].act, PSTR("SW"),2))  TIMER_Start(i,!TIMER[i].on_off); else
          { 
            uint16_t tmp_timer=chr_to_int(char_parsung[2].act);
            if (tmp_timer) TIMER[i].timer = tmp_timer;  // 
            if (char_parsung[3].len) TIMER[i].timer = chr_to_int(char_parsung[3].act);
            TIMER_Start(i,true);
          }
        }
    } else
    FOR_i(0,MAX_TIMER) {
     if (!strcmp_P(char_parsung[0].act, PSTR("P_OFF"))) {
        if (TIMER[i].on_off) {
          TIMER_Start(i,false);
          TIMER[i].on_off=false;
        }
     } else
     if (!strcmp(act, TIMER[i].timer_name)) TIMER_Start(i,true); else
     if (!strcmp(char_parsung[0].act, TIMER[i].timer_name)) {
        if (!strncmp_P(char_parsung[1].act, PSTR("OF"),2)) TIMER_Start(i,false); else
        if (!strncmp_P(char_parsung[1].act, PSTR("SW"),2))  TIMER_Start(i,!TIMER[i].on_off);  else
        { 
           uint16_t tmp_timer=chr_to_int(char_parsung[1].act);
           if (tmp_timer) TIMER[i].timer = tmp_timer;  // 
           TIMER_Start(i,true); 
        } 
     }
    }

   if (!strcmp_P(char_parsung[3].act, PSTR(""))) return;

}
//--------------------------------------------------------
void TIMER_Start(uint8_t tim,bool ON_OFF) {
  if (tim<MAX_TIMER) {
    TIMER[tim].on_off=ON_OFF;
    TIMER[tim].tik_tik=millis()+TIMER[tim].timer*60000+1000;
    DEBUG("TIMER_Start : ");
    DEBUGLN((TIMER[tim].tik_tik-millis())/1000);
    if (ON_OFF) {
       send_on_time(tim,TIMER[tim].cmd_start);
       TIMER[tim].ok=false;
    }
    else if (strcmp(TIMER[tim].timer_name,TIMER[tim].cmd)!=0) {
      send_on_time(tim,TIMER[tim].cmd);
    }
  }
}
//--------------------------------------------------------
void HUB_module_pult_TIMER(gh::Builder& b) {
  char arg1[30];
  FOR_i(0,MAX_TIMER) 
   if (TIMER[i].on_off || strlen(TIMER[i].timer_name)){
    b.beginRow();  
    sprintf_P(arg1, (const char *)F("Имя %d таймера"), i);
    b.Display(TIMER[i].timer_name).label(arg1).fontSize(16).rows(1).size(4).color(TIMER[i].col);
    show_tik_TIM(b,i);
    sprintf_P(arg1, (const char *)F("sw_TIM%d"), i);
    if (b.Switch_(arg1,&TIMER[i].on_off).label(F("Active")).color(TIMER[i].col).click() ) TIMER_Start(i,TIMER[i].on_off);
    b.endRow();  
  }
}
//--------------------------------------------------------
void HUB_module_TIMER(gh::Builder& b) {
  static uint8_t plus_minus[MAX_TIMER];
  char arg1[10];
  char arg2[20];
  
  FOR(tab,0,MAX_TIMER) {
     b.beginRow();  
     sprintf_P(arg1, (const char *)F("sw_TIM%d"), tab);
     sprintf_P(arg2, (const char *)F("%d. Active"), tab);
     if (b.Switch_(arg1,&TIMER[tab].on_off).label(arg2).color(TIMER[tab].col).size(1).click()) TIMER_Start(tab,TIMER[tab].on_off);
     eeprom_flag |= b.Input(TIMER[tab].timer_name).maxLen(HUB_LEN).color(TIMER[tab].col).size(3).label(F("Имя таймера / Условие")).click();
     if (b.Tabs(&plus_minus[tab]).text(F("- ; +")).size(1).color(TIMER[tab].col).click()) b.refresh();
     b.endRow();  
     if (plus_minus[tab]) {
         b.beginRow();  
         sprintf_P(arg2, (const char *)F("Таймер %d"), tab);
         eeprom_flag |= b.Input(&TIMER[tab].timer).label(arg2).click();
         show_tik_TIM(b,tab);
         b.endRow();  
         b.beginRow();  
         eeprom_flag |= b.Time(&TIMER[tab].time_from).label(F("От")).size(2).click();
         eeprom_flag |= b.Time(&TIMER[tab].time_to).label(F("До")).size(2).click();
         eeprom_flag |= b.Color(&TIMER[tab].col).click();
         b.endRow();  
         eeprom_flag |= b.Flags(&TIMER[tab].week).text(str_dayofweek).label(F("Дни недели")).click();
         eeprom_flag |= b.Input(TIMER[tab].cmd_start).label(F("Команда при старте")).maxLen(HUB_LEN).click();
         eeprom_flag |= b.Input(TIMER[tab].cmd_active).label(F("Команда при активности")).maxLen(HUB_LEN).click();
         eeprom_flag |= b.Input(TIMER[tab].cmd).label(F("Команда на финише")).maxLen(HUB_LEN).click();
         eeprom_flag |= b.Flags(&TIMER[tab].lamp).text(str_GHflags_IP).label(F("Устройства IP")).click();
         eeprom_flag |= b.Flags(&TIMER[tab].modul).text(str_modul).label(hlp_modul).click();
     }
  }
  if (eeprom_flag) {
      FS_UPDATE(TIMER);
      eeprom_flag=false;
  }
}
//--------------------------------------------------------
/*void load_TIMER(){

}
*/
#endif
